/**
 * Copyright (c) 2010-2012 Ed Merks and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *   Ed Merks - Initial API and implementation
 */
package org.eclipse.emf.ecore.provider;

import com.google.gwt.i18n.client.Messages;

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public interface EcoreEditPluginProperties extends Messages
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_CreateChild_text")
  @DefaultMessage("{0}")
  String createChildText(Object type);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_CreateChild_text2")
  @DefaultMessage("{1} {0}")
  String createChildText2(Object type, Object feature);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_CreateChild_text3")
  @DefaultMessage("{0}")
  String createChildText3(Object feature);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_CreateChild_tooltip")
  @DefaultMessage("Create New {0} Under {1} Feature")
  String createChildTooltip(Object type, Object feature);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_CreateChild_description")
  @DefaultMessage("Create a new child of type {0} for the {1} feature of the selected {2}.")
  String createChildDescripition(Object type, Object feature, Object selection);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_CreateSibling_description")
  @DefaultMessage("Create a new sibling of type {0} for the selected {2}, under the {1} feature of their parent.")
  String createSiblingDescription(Object type, Object feature, Object selection);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_PropertyDescriptor_description")
  @DefaultMessage("The {0} of the {1}")
  String propertyDescriptorDescription(Object feature, Object type);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAttribute_type")
  @DefaultMessage("EAttribute")
  String eAttributeType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAnnotation_type")
  @DefaultMessage("EAnnotation")
  String eAnnotationType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_type")
  @DefaultMessage("EClass")
  String eClassType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_type")
  @DefaultMessage("EClassifier")
  String eClassifierType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EDataType_type")
  @DefaultMessage("EData Type")
  String eDataTypeType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EEnum_type")
  @DefaultMessage("EEnum")
  String eEnumType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EEnumLiteral_type")
  @DefaultMessage("EEnum Literal")
  String eEnumLiteralType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EFactory_type")
  @DefaultMessage("EFactory")
  String eFactoryType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EModelElement_type")
  @DefaultMessage("EModel Element")
  String eModelElementType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ENamedElement_type")
  @DefaultMessage("ENamed Element")
  String eNamedElementType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EObject_type")
  @DefaultMessage("EObject")
  String eObjectType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EOperation_type")
  @DefaultMessage("EOperation")
  String eOperationType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_type")
  @DefaultMessage("EPackage")
  String ePackageType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EParameter_type")
  @DefaultMessage("EParameter")
  String eParameterType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_type")
  @DefaultMessage("EReference")
  String eReferenceType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_type")
  @DefaultMessage("EStructural Feature")
  String eStructuralFeatureType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_type")
  @DefaultMessage("ETyped Element")
  String eTypedElementType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStringToStringMapEntry_type")
  @DefaultMessage("EString To String Map Entry")
  String eStringToStringMapEntryType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_type")
  @DefaultMessage("EGeneric Type")
  String eGenericTypeType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypeParameter_type")
  @DefaultMessage("EType Parameter")
  String eTypeParameterType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_Unknown_type")
  @DefaultMessage("Object")
  String unknownType();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_Unknown_datatype")
  @DefaultMessage("Value")
  String unknownDatatype();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAttribute_iD_feature")
  @DefaultMessage("ID")
  String eAttribute_IDFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAttribute_iD_description")
  @DefaultMessage("Whether the value of this attribute uniquely identifies an object within its containing resource")
  String eAttribute_IDDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAttribute_eAttributeType_feature")
  @DefaultMessage("EAttribute Type")
  String eAttribute_EAttributeTypeFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAttribute_eAttributeType_description")
  @DefaultMessage("The data type of this attribute")
  String eAttribute_EAttributeTypeDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAnnotation_source_feature")
  @DefaultMessage("Source")
  String eAnnotation_SourceFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAnnotation_source_description")
  @DefaultMessage("An identifier, typically an absolute URI, that uniquely identifies this kind of annotation")
  String eAnnotation_SourceDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAnnotation_details_feature")
  @DefaultMessage("Details")
  String eAnnotation_DetailsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAnnotation_eModelElement_feature")
  @DefaultMessage("EModel Element")
  String eAnnotation_EModelElementFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAnnotation_contents_feature")
  @DefaultMessage("Contents")
  String eAnnotation_ContentsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAnnotation_references_feature")
  @DefaultMessage("References")
  String eAnnotation_ReferencesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EAnnotation_references_description")
  @DefaultMessage("Objects referenced by this annotation")
  String eAnnotation_ReferencesDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_abstract_feature")
  @DefaultMessage("Abstract")
  String eClass_AbstractFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_abstract_description")
  @DefaultMessage("Whether instances of this class can be created")
  String eClass_AbstractDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_interface_feature")
  @DefaultMessage("Interface")
  String eClass_InterfaceFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_interface_description")
  @DefaultMessage("Whether no corresponding implementation will be generated for this class")
  String eClass_InterfaceDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eSuperTypes_feature")
  @DefaultMessage("ESuper Types")
  String eClass_ESuperTypesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eSuperTypes_description")
  @DefaultMessage("The immediate super types of this class")
  String eClass_ESuperTypesDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eOperations_feature")
  @DefaultMessage("EOperations")
  String eClass_EOperationsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eOperations_description")
  @DefaultMessage("The operations defined by this class")
  String eClass_EOperationsDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eAllAttributes_feature")
  @DefaultMessage("EAll Attributes")
  String eClass_EAllAttributesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eAllReferences_feature")
  @DefaultMessage("EAll References")
  String eClass_EAllReferencesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eReferences_feature")
  @DefaultMessage("EReferences")
  String eClass_EReferencesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eAttributes_feature")
  @DefaultMessage("EAttributes")
  String eClass_EAttributesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eAllContainments_feature")
  @DefaultMessage("EAll Containments")
  String eClass_EAllContainmentsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eAllOperations_feature")
  @DefaultMessage("EAll Operations")
  String eClass_EAllOperationsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eAllStructuralFeatures_feature")
  @DefaultMessage("EAll Structural Features")
  String eClass_EAllStructuralFeaturesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eAllSuperTypes_feature")
  @DefaultMessage("EAll Super Types")
  String eClass_EAllSuperTypesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eIDAttribute_feature")
  @DefaultMessage("EID Attribute")
  String eClass_EIDAttributeFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eStructuralFeatures_feature")
  @DefaultMessage("EStructural Features")
  String eClass_EStructuralFeaturesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eGenericSuperTypes_feature")
  @DefaultMessage("EGeneric Super Types")
  String eClass_EGenericSuperTypesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClass_eAllGenericSuperTypes_feature")
  @DefaultMessage("EAll Generic Super Types")
  String eClass_EAllGenericSuperTypesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_instanceClassName_feature")
  @DefaultMessage("Instance Class Name")
  String eClassifier_InstanceClassNameFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_instanceClassName_description")
  @DefaultMessage("The erased instance class name denoted by this classifier")
  String eClassifier_InstanceClassNameDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_instanceClass_feature")
  @DefaultMessage("Instance Class")
  String eClassifier_InstanceClassFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_defaultValue_feature")
  @DefaultMessage("Default Value")
  String eClassifier_DefaultValueFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_defaultValue_description")
  @DefaultMessage("The default value for features of this type")
  String eClassifier_DefaultValueDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_instanceTypeName_feature")
  @DefaultMessage("Instance Type Name")
  String eClassifier_InstanceTypeNameFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_instanceTypeName_description")
  @DefaultMessage("The full instance type name denoted by this classifier")
  String eClassifier_InstanceTypeNameDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_ePackage_feature")
  @DefaultMessage("EPackage")
  String eClassifier_EPackageFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EClassifier_eTypeParameters_feature")
  @DefaultMessage("EType Parameters")
  String eClassifier_ETypeParametersFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EDataType_serializable_feature")
  @DefaultMessage("Serializable")
  String eDataType_SerializableFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EDataType_serializable_description")
  @DefaultMessage("Whether a value of this data type can be serialized using the factory")
  String eDataType_SerializableDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EEnum_eLiterals_feature")
  @DefaultMessage("ELiterals")
  String eEnum_ELiteralsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EEnumLiteral_value_feature")
  @DefaultMessage("Value")
  String eEnumLiteral_ValueFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EEnumLiteral_value_description")
  @DefaultMessage("The integer value associated with this enumerator")
  String eEnumLiteral_ValueDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EEnumLiteral_instance_feature")
  @DefaultMessage("Instance")
  String eEnumLiteral_InstanceFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EEnumLiteral_literal_feature")
  @DefaultMessage("Literal")
  String eEnumLiteral_LiteralFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EEnumLiteral_literal_description")
  @DefaultMessage("The literal value associated with this enumerator")
  String eEnumLiteral_LiteralDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EEnumLiteral_eEnum_feature")
  @DefaultMessage("EEnum")
  String eEnumLiteral_EEnumFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EFactory_ePackage_feature")
  @DefaultMessage("EPackage")
  String eFactory_EPackageFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EFactory_ePackage_description")
  @DefaultMessage("The package corresponding to this factory")
  String eFactory_EPackageDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EModelElement_eAnnotations_feature")
  @DefaultMessage("EAnnotations")
  String eModelElement_EAnnotationsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ENamedElement_name_feature")
  @DefaultMessage("Name")
  String eNamedElement_NameFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ENamedElement_name_description")
  @DefaultMessage("The name of this model element")
  String eNamedElement_NameDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EOperation_eContainingClass_feature")
  @DefaultMessage("EContaining Class")
  String eOperation_EContainingClassFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EOperation_eTypeParameters_feature")
  @DefaultMessage("EType Parameters")
  String eOperation_ETypeParametersFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EOperation_eParameters_feature")
  @DefaultMessage("EParameters")
  String eOperation_EParametersFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EOperation_eExceptions_feature")
  @DefaultMessage("EExceptions")
  String eOperation_EExceptionsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EOperation_eExceptions_description")
  @DefaultMessage("The exceptions thrown by this operation")
  String eOperation_EExceptionsDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EOperation_eGenericExceptions_feature")
  @DefaultMessage("EGeneric Exceptions")
  String eOperation_EGenericExceptionsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_nsURI_feature")
  @DefaultMessage("Ns URI")
  String ePackage_NsURIFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_nsURI_description")
  @DefaultMessage("The universally unique namespace identifier, typically an absolute URI, for this package")
  String ePackage_NsURIDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_nsPrefix_feature")
  @DefaultMessage("Ns Prefix")
  String ePackage_NsPrefixFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_nsPrefix_description")
  @DefaultMessage("The namespace prefix used by default when serializing instances of the package''s classes")
  String ePackage_NsPrefixDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_eFactoryInstance_feature")
  @DefaultMessage("EFactory Instance")
  String ePackage_EFactoryInstanceFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_eFactoryInstance_description")
  @DefaultMessage("The factory corresponding to this package")
  String ePackage_EFactoryInstanceDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_eClassifiers_feature")
  @DefaultMessage("EClassifiers")
  String ePackage_EClassifiersFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_eSubpackages_feature")
  @DefaultMessage("ESubpackages")
  String ePackage_ESubpackagesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EPackage_eSuperPackage_feature")
  @DefaultMessage("ESuper Package")
  String ePackage_ESuperPackageFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EParameter_eOperation_feature")
  @DefaultMessage("EOperation")
  String eParameter_EOperationFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_containment_feature")
  @DefaultMessage("Containment")
  String eReference_ContainmentFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_containment_description")
  @DefaultMessage("Whether this reference represents a composite relationship")
  String eReference_ContainmentDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_container_feature")
  @DefaultMessage("Container")
  String eReference_ContainerFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_container_description")
  @DefaultMessage("Whether this reference has as its opposite a containment reference")
  String eReference_ContainerDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_resolveProxies_feature")
  @DefaultMessage("Resolve Proxies")
  String eReference_ResolveProxiesFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_resolveProxies_description")
  @DefaultMessage("Whether this reference resolves proxies automatically")
  String eReference_ResolveProxiesDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_eOpposite_feature")
  @DefaultMessage("EOpposite")
  String eReference_EOppositeFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_eOpposite_description")
  @DefaultMessage("The reference that represents the bidirectional opposite of this reference")
  String eReference_EOppositeDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_eReferenceType_feature")
  @DefaultMessage("EReference Type")
  String eReference_EReferenceTypeFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_eReferenceType_description")
  @DefaultMessage("The target class of the reference")
  String eReference_EReferenceTypeDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_eKeys_feature")
  @DefaultMessage("EKeys")
  String eReference_EKeysFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EReference_eKeys_description")
  @DefaultMessage("The attributes of the referenced class that uniquely identify a referenced instance")
  String eReference_EKeysDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_changeable_feature")
  @DefaultMessage("Changeable")
  String eStructuralFeature_ChangeableFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_changeable_description")
  @DefaultMessage("Whether the value of this feature can be changed")
  String eStructuralFeature_ChangeableDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_volatile_feature")
  @DefaultMessage("Volatile")
  String eStructuralFeature_VolatileFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_volatile_description")
  @DefaultMessage("Whether no field will be generated for this feature")
  String eStructuralFeature_VolatileDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_transient_feature")
  @DefaultMessage("Transient")
  String eStructuralFeature_TransientFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_transient_description")
  @DefaultMessage("Whether the value of this feature will be serialized")
  String eStructuralFeature_TransientDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_defaultValueLiteral_feature")
  @DefaultMessage("Default Value Literal")
  String eStructuralFeature_DefaultValueLiteralFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_defaultValueLiteral_description")
  @DefaultMessage("The literal representation of the default value for this feature")
  String eStructuralFeature_DefaultValueLiteralDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_defaultValue_feature")
  @DefaultMessage("Default Value")
  String eStructuralFeature_DefaultValueFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_defaultValue_description")
  @DefaultMessage("The default value for this feature")
  String eStructuralFeature_DefaultValueDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_unsettable_feature")
  @DefaultMessage("Unsettable")
  String eStructuralFeature_UnsettableFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_unsettable_description")
  @DefaultMessage("Whether the value space for this feature includes the state of not being set")
  String eStructuralFeature_UnsettableDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_derived_feature")
  @DefaultMessage("Derived")
  String eStructuralFeature_DerivedFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_derived_description")
  @DefaultMessage("Whether the value of this feature is derived from the values of other features")
  String eStructuralFeature_DerivedDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_eContainingClass_feature")
  @DefaultMessage("EContaining Class")
  String eStructuralFeature_EContainingClassFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStructuralFeature_eContainingClass_description")
  @DefaultMessage("The class that defines this feature")
  String eStructuralFeature_EContainingClassDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_ordered_feature")
  @DefaultMessage("Ordered")
  String eTypedElement_OrderedFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_ordered_description")
  @DefaultMessage("Whether the order in which values occur is meaningful")
  String eTypedElement_OrderedDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_unique_feature")
  @DefaultMessage("Unique")
  String eTypedElement_UniqueFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_unique_description")
  @DefaultMessage("Whether the same value may occur more than once")
  String eTypedElement_UniqueDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_lowerBound_feature")
  @DefaultMessage("Lower Bound")
  String eTypedElement_LowerBoundFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_lowerBound_description")
  @DefaultMessage("The minimum number of values that must occur")
  String eTypedElement_LowerBoundDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_upperBound_feature")
  @DefaultMessage("Upper Bound")
  String eTypedElement_UpperBoundFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_upperBound_description")
  @DefaultMessage("The maximum number of values that may occur; -1 represents unbounded and -2 represents unspecified")
  String eTypedElement_UpperBoundDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_many_feature")
  @DefaultMessage("Many")
  String eTypedElement_ManyFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_many_description")
  @DefaultMessage("Whether more than one value may occur")
  String eTypedElement_ManyDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_required_feature")
  @DefaultMessage("Required")
  String eTypedElement_RequiredFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_required_description")
  @DefaultMessage("Whether at least one value must occur")
  String eTypedElement_RequiredDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_eType_feature")
  @DefaultMessage("EType")
  String eTypedElement_ETypeFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_eType_description")
  @DefaultMessage("The type of this element")
  String eTypedElement_ETypeDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypedElement_eGenericType_feature")
  @DefaultMessage("EGeneric Type")
  String eTypedElement_EGenericTypeFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStringToStringMapEntry_key_feature")
  @DefaultMessage("Key")
  String eStringToStringMapEntry_KeyFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStringToStringMapEntry_key_description")
  @DefaultMessage("The key of this map entry")
  String eStringToStringMapEntry_KeyDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStringToStringMapEntry_value_feature")
  @DefaultMessage("Value")
  String eStringToStringMapEntry_ValueFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EStringToStringMapEntry_value_description")
  @DefaultMessage("The value of this map entry")
  String eStringToStringMapEntry_ValueDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_eUpperBound_feature")
  @DefaultMessage("EUpper Bound")
  String eGenericType_EUpperBoundFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_eTypeArguments_feature")
  @DefaultMessage("EType Arguments")
  String eGenericType_ETypeArgumentsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_eRawType_feature")
  @DefaultMessage("ERaw Type")
  String eGenericType_ERawTypeFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_eRawType_description")
  @DefaultMessage("The erased type denoted by this generic type")
  String eGenericType_ERawTypeDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_eLowerBound_feature")
  @DefaultMessage("ELower Bound")
  String eGenericType_ELowerBoundFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_eTypeParameter_feature")
  @DefaultMessage("EType Parameter")
  String eGenericType_ETypeParameterFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_eTypeParameter_description")
  @DefaultMessage("The type parameter denoted by this generic type")
  String eGenericType_ETypeParameterDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_eClassifier_feature")
  @DefaultMessage("EClassifier")
  String eGenericType_EClassifierFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_EGenericType_eClassifier_description")
  @DefaultMessage("The classifier denoted by this generic type")
  String eGenericType_EClassifierDescription();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_ETypeParameter_eBounds_feature")
  @DefaultMessage("EBounds")
  String eTypeParameter_EBoundsFeature();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Key("_UI_Unknown_feature")
  @DefaultMessage("Unspecified")
  String unknownFeature();

}
